<?php //
//$t = 120;
//ini_set("max_execution_time", $t);
set_time_limit(120); // Script timeout in seconds, need some high value for LibreOffice etc
include("engine.php");
if ($EnableUTF8) {
	header('Content-Type: application/json; charset=utf-8');
}

////$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)
$gdata = $_GET; // Parameters

$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $gdata["Action"]; // returns the Action/ Action code, same as request
$ret["data"] = ""; // contains payload/ return data
$ret["message"] = ""; // contains error message, if any

$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)

if ($EnableUTF8) {
	$jdata = deutf8ize($jdata);
}

/*if (isset($_GET["wsid"])) {
	$wsid = $_GET["wsid"];
}
if (isset($jdata["wsid"])) {
	$wsid = $jdata["wsid"];
}*/

if ($gdata["Action"] == "GetUploadDirectory") {
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$updirname = $Nowprecise;
	$uploaddir = join(DIRECTORY_SEPARATOR, array($uploadlocation, $updirname)); //uploadloclation unused at the moment. Upload is done manally by admin
	$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
	$i = 0;
	while (is_dir(join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir)))) {
		$r = rand(1, 10000);
		$dd = new DateTime();
		$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
		$updirname = $Nowpreciseupdated . $i . $r;
		$uploaddir = join(DIRECTORY_SEPARATOR, array($uploadlocation, $updirname));
		$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
		$i = $i + 1;
		if ($i > 100) {
			// timeout? ... // exit;
		}
	}
	$rr = mkdir($uploaddircomplete);
	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	try {
		$conn = DBOpenConnection();
		$sql = "SELECT * FROM canvas WHERE id = :id AND code = :code AND enabled = 1";
		$stmt = $conn->prepare($sql);
		$stmt->bindValue(':id', $id, PDO::PARAM_INT);
		$stmt->bindValue(':code', $code, PDO::PARAM_STR);

		$stmt->execute(); // true or false
		$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

		$res = $stmt->fetchAll();

		if (count($res) > 0) {
			$info["id"] = intval($res[0]["id"]);
			$info["name"] = $res[0]["name"];
			$info["registration"] = $res[0]["registration"];
			$info["lastLogin"] = $res[0]["lastLogin"];
			$info["count"] = intval($res[0]["count"]) + 1;
			$info["enabled"] = intval($res[0]["enabled"]);
		}

		if ($info["enabled"] == true)
		{
			$sql = "UPDATE canvas SET count = :count, lastLogin = '$Nowed' WHERE id = :id";
			$stmt = $conn->prepare($sql);
			$stmt->bindValue(':id', $id, PDO::PARAM_INT);
			$stmt->bindValue(':count', $info["count"], PDO::PARAM_INT);
			$stmt->execute(); // true or false
		}
	}
	catch(PDOException $e) {
	    $ret["status"] = false;
	    $ret["message"] = $e->getMessage();
	}
	$conn = null;





	// Find templates in ("uploads/$id" directory)  ?? -> in images/users/$id !
	$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
	$templates = [];
	if (file_exists($usertemplates)) {
		$files = scandir($usertemplates);
		foreach($files as $file) {
			$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $file));
			if (!is_dir($file)) {
				// Extract extension
				$exp = explode(".", $file);
				$ext = end($exp);
				// is image?
				//  if (in_array($ext, $imgextensions)) {    // commented out, ekkard: all files should be shown
					array_push($templates, $file);
                //}   commented out, ekkard
			}
		}
	}
	$rdata["Templates"] = $templates;
	$rdata["Info"] = $info;

	// Placeholder common output files...
	if ($rr) {
		$rdata["Directory"] = str_replace("\\", "/", $uploaddir);
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = "mkdir(\"" . $uploaddir . "\"); successful. Work directory for this session is: <strong>" . $uploaddir . "</strong>"; // contains error message, if any
	} else {
		$ret["status"] = false; // status, true on success, false on failure/ error
		$ret["data"] = ""; // contains payload/ return data
		$ret["message"] = "Unable to mkdir(\"" . $uploaddir . "\"); Please check permissions to <strong>" . $uploadlocation . "</strong> directory."; // contains error message, if any
	}

	// Directory cleanup code for old working directories for LibreOffice etc
	$dnow = date("YmdHi");
	$dirs = scandir(join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation)));
	foreach($dirs as $dir) {
		$ft = 0;
		$dircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $dir));

		if ((trim($dir) != ".") && (trim($dir) != "..") && (is_dir($dircomplete)) && (trim($dircomplete) != $uploaddircomplete)) {
			$dircontents = scandir($dircomplete);
			//echo "dir: \t" . $dircomplete . "\n";
			//print_r($dircontents);
			foreach($dircontents as $f) {
				$fcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $dir, $f));
				if ((trim($f) != ".") && (trim($f) != "..") && (!is_dir($f))) {
					$fd = date("YmdHi", filemtime($fcomplete));
					//echo "fd:	\t" . $fd . "\n";
					//echo "ft:	\t" . $ft . "\n";
					if ($fd >= $ft) {
						$ft = $fd;
					}
				}
			}
			if (($dnow - $ft) > 100) { // more than 100 minutes old
				//echo "yes	\t" . $dir . "\n";
				//echo "Now: \t\t" . $dnow . "\n";
				//echo "Filetime: \t" . $ft . "\n";
				if (DIRECTORY_SEPARATOR == "\\") {
					$ex = "rmdir /S /Q \"" . trim($dircomplete) . "\"";
				} else {
					$ex = "rm -rf \"" . trim($dircomplete) . "\"";
				}
				//echo $dircomplete . "\n";
				//$r = rmdir(trim($dircomplete));

				//exec($ex, $output, $r);
				$r = removedir(trim($dircomplete));
				if (!($r)) {
					echo "Error removing: " . trim($dircomplete) . "<br />\n";
				}
			}
			//echo $dir . "	\t" . $dnow . "	\t" . $fd . "\n";
		}
	}
}

if ($gdata["Action"] == "Register") {
	include("SendEmail.php");
	$name = trim($jdata["Name"]);
	$email = trim($jdata["Email"]);
	$phone = trim($jdata["Phone"]);
	$code = random_str($passwordlength);

	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["email"] = "";
	$info["phone"] = "";
	$info["code"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	$r = false;

	try {
		$conn = DBOpenConnection();

		$stmt = $conn->prepare("INSERT INTO canvas (name, email, phone, code, registration, lastLogin, count, enabled) VALUES (:name, :email, :phone, :code, '$Nowed', '$Nowed', 0, 1)");
	    $stmt->bindValue(':name', $name, PDO::PARAM_STR);
	    $stmt->bindValue(':email', $email, PDO::PARAM_STR);
	    $stmt->bindValue(':phone', $phone, PDO::PARAM_STR);
	    $stmt->bindValue(':code', $code, PDO::PARAM_STR);
	    $r = $stmt->execute(); // true or false

	    if ($r) {
			$sql = "SELECT * FROM canvas WHERE name = :name AND email = :email AND phone = :phone AND code = :code AND registration = '$Nowed' AND enabled = 1";
			$stmt = $conn->prepare($sql);
			$stmt->bindValue(':name', $name, PDO::PARAM_STR);
			$stmt->bindValue(':email', $email, PDO::PARAM_STR);
			$stmt->bindValue(':phone', $phone, PDO::PARAM_STR);
			$stmt->bindValue(':code', $code, PDO::PARAM_STR);

			$stmt->execute(); // true or false
			$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

			$res = $stmt->fetchAll();

			if (count($res) > 0) {
				$info["id"] = intval($res[0]["id"]);
				$info["name"] = $res[0]["name"];
				$info["email"] = $res[0]["email"];
				$info["phone"] = $res[0]["phone"];
				$info["code"] = $res[0]["code"];
				$info["registration"] = $res[0]["registration"];
				$info["lastLogin"] = $res[0]["lastLogin"];
				$info["count"] = intval($res[0]["count"]);
				$info["enabled"] = intval($res[0]["enabled"]);

				// Copy templates to user images
				$dirpath = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $info["id"]));
				if (!file_exists($dirpath)) {
					mkdir($dirpath);
					// Copy images to users
					$templateslocationcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $templateslocation));
					$templates = [];
					if ((file_exists($dirpath)) && (file_exists($templateslocationcomplete))) {
						$files = scandir($templateslocationcomplete);
						foreach($files as $file) {
							$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $templateslocation, $file));
							if (!is_dir($file)) {
								// Extract extension
								$exp = explode(".", $file);
								$ext = end($exp);
								$filedestinationcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $info["id"], $file));
								// is image?
								if (in_array($ext, $imgextensions)) {
									copy($filecomplete, $filedestinationcomplete);
								}
							}
						}
					}
				}
				// Send email confirmation
				$Subject = "[canvas@archiv] Canvas registration";
				$Message = "Somebody with your email address demanded a code: <strong>" . $info['code'] . "</strong><br /><br />
If you didn't order this code, then excuse me and ignore this email.<br /><br />
<strong>Eckard Gerlach</strong><br />
<a href=\"mailto:egerlach@zeitprax.com\">egerlach@zeitprax.com</a>";

				$contact = [];
				$contact[0] = [];
				$contact [0]["Name"] = $info["name"];
				$contact [0]["EMail"] = $info["email"];

				$Ccemail = "egerlach@zeitprax.com";
				$sf = SendEmail($contact, $Ccemail, $Subject, $Message, false, "");
				if ($sf[0] === true) {
					$r = true;
				} else {
					$r = false;
					$ret["message"] = "The email system returned error code: <strong>" . $sf[1] . "</strong>.<br /><strong>Description: </strong>" . $sf[2]; // contains error message, if any
				}
			/*} elseif (count($res) > 1) {
				$ret["status"] = false;
				$ret["message"] = "More than one entry found with same 'id'.";*/
			} else {
				$r = false;
				$ret["message"] = "Record insertion verification failed when retrieving 'id'.";
			}
		}
		else {
			$r = false;
			$ret["message"] = "\$stmt->execute() returned false";
		}
	}
	catch(PDOException $e) {
	    $ret["status"] = false;
	    $ret["message"] = $e->getMessage();
	}
	$conn = null;


	$rdata["info"] = $info;

	// Placeholder common output files...
	if ($r) {
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = 'xzxRegistration successful. Please note the code sent to your email address: <strong>' . $info["email"] . '</strong><br /><br />Url: <a href="https://w99.zeitprax.com/canvas/canvas.php?width=650&height=800&id=' . $info["id"] . '&code=" target="_blank">https://w99.zeitprax.com/canvas/canvas.php?width=650&height=800&id=' . $info["id"] . '&code=</a><br /><br />xzxPlease append the code to the URL to login.'; // contains error message, if any
	} else {
		$ret["status"] = false; // status, true on success, false on failure/ error
		$ret["data"] = ""; // contains payload/ return data
		$ret["message"] = "Registration failed.<br /><strong>Error:</strong><br /><br />" . $ret["message"]; // contains error message, if any
	}
}


if ($gdata["Action"] == "SaveCanvasToPDF") {
	$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
	$decodedData = base64_decode($data);

	$uploaddir = str_replace("/", DIRECTORY_SEPARATOR, $jdata["Directory"]);
	$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
	$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "save.png"));
	$fp = fopen($file_upload, 'wb');
	fwrite($fp, $decodedData);
	fclose($fp);



	$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, "LibreOffice" . $Nowprecise));
	$i = 0;
	while (is_dir($LOprofilepath)) {
		$r = rand(1, 10000);
		$dd = new DateTime();
		$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
		$i = $i + 1;
		$LOprofiledir = "LibreOffice" . $Nowpreciseupdated . $i . $r;
		//$LOprofilepath = str_replace("\\", "/", $LOprofilerootpath). "/" . $LOprofiledir;
		$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOprofiledir));
		if ($i > 100) {
			//exit;
		}
	}
	mkdir($LOprofilepath);
	$LOprofilepath1 = $LOprofilepath . "1";
	mkdir($LOprofilepath1);
	$LOprofilepath = str_replace("\\", "/", $LOprofilepath);
	$LOprofilepath1 = str_replace("\\", "/", $LOprofilepath1);

	//if(in_array($file_ext, $extensions) === true) {
		//echo sys_get_temp_dir();
		$LOhomedir = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOhome));
		if (!is_dir($LOhomedir)) {
			mkdir($LOhomedir);
		}
		putenv("HOME=" . $LOhomedir); // could change to getcwd() . $uploadlocation
		//if ($file_ext != "pdf") {
			$LOcomm = "--headless \"-env:UserInstallation=file:///" . $LOprofilepath . "\" --writer --convert-to pdf:writer_pdf_Export --outdir \"" . $uploaddircomplete . "\" \"" . $file_upload . "\"";// 2>&1";

			$ex = $LObinarypath . " $LOcomm 2>&1";
			//echo ".......";
			exec($ex, $output, $r);
			//echo ">>> " . $ex . "</br>\n";
			//print_r($output);
			//echo "<br />\n\n<br />";
			//echo ">>>" . $ex . "\n\n";
			//echo "Return code: " . $r . "\n";
			if ($r) {
				echo $ex . "\n";
				print_r($output);
				echo "Return code: " . $r . "\n";
			}
		//}
		$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "save.pdf"));
		$rdata["PDF"] = "canvas.pdf";
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = '<a href="' . $uploaddir . '/save.png" target="_blank">Download png</a><br /><br /><a href="' . $uploaddir . '/save.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
	//}
}


if ($gdata["Action"] == "SaveCanvasToPDF") {
	$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
	$decodedData = base64_decode($data);

	$uploaddir = str_replace("/", DIRECTORY_SEPARATOR, $jdata["Directory"]);
	$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
	$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "save.png"));
	$fp = fopen($file_upload, 'wb');
	fwrite($fp, $decodedData);
	fclose($fp);



	$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, "LibreOffice" . $Nowprecise));
	$i = 0;
	while (is_dir($LOprofilepath)) {
		$r = rand(1, 10000);
		$dd = new DateTime();
		$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
		$i = $i + 1;
		$LOprofiledir = "LibreOffice" . $Nowpreciseupdated . $i . $r;
		//$LOprofilepath = str_replace("\\", "/", $LOprofilerootpath). "/" . $LOprofiledir;
		$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOprofiledir));
		if ($i > 100) {
			//exit;
		}
	}
	mkdir($LOprofilepath);
	$LOprofilepath1 = $LOprofilepath . "1";
	mkdir($LOprofilepath1);
	$LOprofilepath = str_replace("\\", "/", $LOprofilepath);
	$LOprofilepath1 = str_replace("\\", "/", $LOprofilepath1);

	//if(in_array($file_ext, $extensions) === true) {
		//echo sys_get_temp_dir();
		$LOhomedir = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOhome));
		if (!is_dir($LOhomedir)) {
			mkdir($LOhomedir);
		}
		putenv("HOME=" . $LOhomedir); // could change to getcwd() . $uploadlocation
		//if ($file_ext != "pdf") {
			$LOcomm = "--headless \"-env:UserInstallation=file:///" . $LOprofilepath . "\" --writer --convert-to pdf:writer_pdf_Export --outdir \"" . $uploaddircomplete . "\" \"" . $file_upload . "\"";// 2>&1";

			$ex = $LObinarypath . " $LOcomm 2>&1";
			//echo ".......";
			exec($ex, $output, $r);
			//echo ">>> " . $ex . "</br>\n";
			//print_r($output);
			//echo "<br />\n\n<br />";
			//echo ">>>" . $ex . "\n\n";
			//echo "Return code: " . $r . "\n";
			if ($r) {
				echo $ex . "\n";
				print_r($output);
				echo "Return code: " . $r . "\n";
			}
		//}
		$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "save.pdf"));
		$rdata["PDF"] = "canvas.pdf";
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = '<a href="' . $uploaddir . '/save.png" target="_blank">Download png</a><br /><br /><a href="' . $uploaddir . '/save.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
	//}
}

if ($gdata["Action"] == "SaveTemplate") {
	$id = intval($jdata["id"]);
	$file = trim($jdata["Template"]);
	$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
	$decodedData = base64_decode($data);

	if (strlen($file) > 0) {
		$exp = explode(".", $file);
		$ext = end($exp);
		if (strtolower($ext) != "png") {
			if (trim($ext) == "") { // there is a "." at the end of filename without non-space character
				$file_name_noext = ""; // can derive from $exp  by substr from file_name
				if (count($exp) > 1) {
					for ($i=0; $i<(count($exp) - 1); $i++) {
						if (strlen($file_name_noext) > 0) {
							$file_name_noext = trim($file_name_noext) . "." . $exp[$i];
						} else {
							$file_name_noext = $exp[$i];
						}
					}
				} else {
					$file_name_noext = $file;
				}
				$file = str_replace(".", "-", $file);
			}
			$file = $file . ".png";
		}
	} else {
		$file = "template.png";
	}

	$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id, $file));
	$fp = fopen($file_upload, 'wb');
	fwrite($fp, $decodedData);
	fclose($fp);

	// Re-find templates in ("uploads/$id" directory)  ?? -> in images/users/$id !
	$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
	$templates = [];
	if (file_exists($usertemplates)) {
		$files = scandir($usertemplates);
		foreach($files as $filef) {
			$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $filef));
			if (!is_dir($filef)) {
				// Extract extension
				$exp = explode(".", $filef);
				$ext = end($exp);
				// is image?
				if (in_array($ext, $imgextensions)) {
					array_push($templates, $filef);
				}
			}
		}
		$rdata["Templates"] = $templates;
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = 'xzxFile saved successfuly as:<br /><br /><strong>' . $file . '</strong><br /><br />xzxThe file is now available as re-usable template.'; // contains error message, if any
	} else {
		$rdata["Templates"] = $templates;
		$ret["status"] = false; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = 'Error saving file.'; // contains error message, if any
	}
	//$ret["message"] .= '<br /><br />Received data:<br /><textarea rows=10 cols=50>' . $jdata["imageData"] . '</textarea><br />Original data:<br /><textarea rows=10 cols=50>' . $data . '</textarea>';
}



if ($EnableUTF8) {
	echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
} else {
	echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
}

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = deutf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}


/**
 * Generate a random string, using a cryptographically secure
 * pseudorandom number generator (random_int)
 *
 * For PHP 7, random_int is a PHP core function
 * For PHP 5.x, depends on https://github.com/paragonie/random_compat
 *
 * @param int $length      How many characters do we want?
 * @param string $keyspace A string of all possible characters
 *                         to select from
 * @return string
 */
function random_str_old(
    $length,
    $keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
    //`~!@#$%^&*()-_+=\|/?[{}]<,>.
    //!#%&*()-+=?<,>.
) {
    $str = '';
    //$max = mb_strlen($keyspace, '8bit') - 1;
    $max = strlen($keyspace) - 1;
    if ($max < 1) {
        throw new Exception('$keyspace must be at least two characters long');
    }
    for ($i = 0; $i < $length; ++$i) {
        $str .= $keyspace[random_int(0, $max)];
    }
    // aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
    //   You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
    //                     2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
    //   Or do you have better idea to reach the aim faster?
    return $str;
}


function random_str(
    $length
) {
	$keys = [];
	$keys[0] = [];
	$keys[0]["keyspace"] = "123456789";   // not use 0 <-> O
	$keys[0]["mincount"] = 1; // how many to include
	$keys[0]["maxcount"] = 1; // how many to include
	$keys[1] = [];
	$keys[1]["keyspace"] = "abcdefghijklmnopqrstuvwxyz";
	$keys[1]["mincount"] = 1; // how many to include
	$keys[1]["maxcount"] = 1; // how many to include
	$keys[2] = [];
	$keys[2]["keyspace"] = "ABCDEFGHIJKLMNPQRSTUVWXYZ"; // not use O <-> 0
	$keys[2]["mincount"] = 1; // how many to include
	$keys[2]["maxcount"] = 1; // how many to include
/*	$keys[3] = [];
	$keys[3]["keyspace"] = "!#%*-+=?,[."; // & ( ) < > ] / \ better not use
	$keys[3]["mincount"] = 1; // how many to include
	$keys[3]["maxcount"] = 1; // how many to include
*/
    $str = '';

    $c = 0;
    while (strlen($str) < $length)
    {
	    for ($i = 0; $i < count($keys); ++$i)
	    {
	        //$max = mb_strlen($keyspace, '8bit') - 1;
		    //$max = strlen($keys[$i]["keyspace"]); - 1;
		    $max = strlen($keys[$i]["keyspace"]) - 1;
		    if ($max < 1) {
		        throw new Exception('$keyspace must be at least two characters long');
		    }
		    $str .= $keys[$i]["keyspace"][random_int(0, $max)];
	    }
	}
	$str = substr($str, 0, $length);
	$exp = str_split($str);
	//shuffle($str);
	shuffle($exp);
	$str = implode("", $exp);
    /*for ($i = 0; $i < $length; ++$i) {
        $str .= $keyspace[random_int(0, $max)];
    }*/
    // aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
    //   You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
    //                     2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
    //   Or do you have better idea to reach the aim faster?
    return $str;
}


function removedir($dir) {
	//$dir = 'samples' . DIRECTORY_SEPARATOR . 'sampledirtree';
	$it = new RecursiveDirectoryIterator($dir, RecursiveDirectoryIterator::SKIP_DOTS);
	$files = new RecursiveIteratorIterator($it,
	             RecursiveIteratorIterator::CHILD_FIRST);
	foreach($files as $file) {
	    if ($file->isDir()){
	        rmdir($file->getRealPath());
	    } else {
	        unlink($file->getRealPath());
	    }
	}
	return rmdir($dir);
}


function removedirs($directory) {
	$dirs = scandir($directory);
	foreach($dirs as $dir) {
		$d = join(DIRECTORY_SEPARATOR, array($directory, $dir));
		if ((trim($dir) != ".") && (trim($dir) != "..") && (is_dir(trim($d)))) {
			if (DIRECTORY_SEPARATOR == "\\") {
				$ex = "rmdir /S /Q \"" . trim($d) . "\"";
			} else {
				$ex = "rm -rf \"" . trim($d) . "\"";
			}
			exec($ex, $output, $r);
			/*if ($r) {
				echo $ex . "\n";
				print_r($output);
				echo "Return code: " . $r . "\n";
			}*/
		}
	}
}


// cleans contact number (telephone, fax) from non-numeric characters
function cleancontactnumber($number) {
	$remchars = [" ", "-", "/", ".", ","];
	foreach ($remchars as $ch)
	{
		$number = str_replace($ch, "", $number);
	}
	return $number;
}

function subst_specialchars_filenames($text) {
    $specialchars=array("!","|","#","*","<",">"," ", "'",",", "/", "\\", "\"", "\:","°",".","`","^");
    $ret=str_replace($specialchars,"_",$text);
    return $ret;
    }

function limittext($text, $length) {
	$ret = $text;
	if (strlen($text) > $length)
	{
		$ret = substr($ret, 0, $length);
	}
	return $ret;
}

function mbStringToArray ($string) {
    $strlen = mb_strlen($string);
    while ($strlen) {
        $array[] = mb_substr($string,0,1,"UTF-8");
        $string = mb_substr($string,1,$strlen,"UTF-8");
        $strlen = mb_strlen($string);
    }
    return $array;
}


function extension($file) {
	$exp = explode(".", $file);
	return end($exp);
}


?>